/*
 DownloadAppThread.java
 
 Created on Oct 4, 2012, 5:17:03 PM
 
 Copyright(c) 2012 Carlos Eduardo Bernal Cárdenas. All Rights Reserved.
 This software is the proprietary information of Carlos Eduardo Bernal Cárdenas.
 */
package googleplay.crawler.util;


import com.gc.android.market.api.MarketSession;
import com.gc.android.market.api.model.Market;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * {Insert class description here}
 *
 * @author Carlos Eduardo Bernal Cárdenas
 * @version 1.0
 * @since Build Oct 4, 2012
 */
public class DownloadAppThread extends Thread {

    private String packageName;
    private String appId;
    private String user;
    private String password;
    private String androidId;
    private String path;

    public DownloadAppThread(String packageName, String appId, String user, String password, String androidId, String path) {
        this.packageName = packageName;
        this.appId = appId;
        this.user = user;
        this.password = password;
        this.androidId = androidId;
        this.path = path;
    }

    @Override
    public void run() {

        MarketSession session = new MarketSession(true);
        session.login(user, password, androidId);
        
        InputStream inputStream = null;
        try {
            Market.GetAssetResponse.InstallAsset ia = session.queryGetAssetRequest(appId).getInstallAsset(0);
            String cookieName = ia.getDownloadAuthCookieName();
            String cookieValue = ia.getDownloadAuthCookieValue();

            String fileToSave =  path + packageName + ".apk";
            System.out.println("Downloading... " + fileToSave);

            //Connection to the server 
            URL url = new URL(ia.getBlobUrl());
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");
            conn.setRequestProperty("User-Agent",
                    "Android-Market/2 (sapphire PLAT-RC33); gzip");
            conn.setRequestProperty("Cookie", cookieName + "=" + cookieValue);
            inputStream = conn.getInputStream();

            //Saving app 
            BufferedOutputStream stream = new BufferedOutputStream(new FileOutputStream(fileToSave));
            byte buf[] =
                    new byte[1024];
            int k = 0;
            for (long l = 0L; (k =
                    inputStream.read(buf)) != -1; l += k) {
                stream.write(buf, 0, k);
            }
            inputStream.close();
            stream.close();
            System.out.println("Downloaded:" + fileToSave);
        } catch (IOException ex) {
            Logger.getLogger(DownloadAppThread.class.getName()).log(Level.SEVERE,
                    null, ex);
        } finally {
            try {
                inputStream.close();
            } catch (IOException ex) {
                Logger.getLogger(DownloadAppThread.class.getName()).log(Level.SEVERE,
                        null, ex);
                
            }
        }
    }
}